controllers/EtapaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Etapa;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EtapaController implements the CRUD actions for Etapa model.
 */
class EtapaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Etapa models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etapa::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Etapa model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Etapa model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Etapa();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->numetapa]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Etapa model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->numetapa]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Etapa model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Etapa model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Etapa the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Etapa::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/LlevaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Lleva;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LlevaController implements the CRUD actions for Lleva model.
 */
class LlevaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Lleva models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Lleva::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Lleva model.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($numetapa, $código)
    {
        return $this->render('view', [
            'model' => $this->findModel($numetapa, $código),
        ]);
    }

    /**
     * Creates a new Lleva model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Lleva();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Lleva model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($numetapa, $código)
    {
        $model = $this->findModel($numetapa, $código);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Lleva model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($numetapa, $código)
    {
        $this->findModel($numetapa, $código)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Lleva model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $numetapa
     * @param string $código
     * @return Lleva the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($numetapa, $código)
    {
        if (($model = Lleva::findOne(['numetapa' => $numetapa, 'código' => $código])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    public function  actionCrud(){
        return $this->render("gestion");
    }
    public function actionConsulta1() {
      // mediante DAO
      $numero=Yii::$app->
              db->
              createCommand('SELECT count(distinct edad) FROM ciclista')
              ->queryScalar();
              
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT edad FROM ciclista',
            'totalCount'=>$numero,
                'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['edad'], 
            "enunciado"=>"Listar las edad de los ciclistas sin repetidos",
             "titulo"=>"Consulta1a",
            "sql"=>"Select distinct from ciclista",
        ]);
        
        
    }
    
    
    
    public function  actionConsulta1a(){
        // mediante active record
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()->distinct()->select("edad"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['edad'], 
            "enunciado"=>"Listar las edad de los ciclistas sin repetidos",
             "titulo"=>"Consulta1a",
            "sql"=>"Select distinct from ciclista",
        ]);
    }
    public function  actionConsulta2(){
        // mediante DAO
      $numero=Yii::$app->
              db->
              createCommand("SELECT count(DISTINCT edad) FROM ciclista WHERE nomequipo = 'artiach'")
              ->queryScalar();
              
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT edad FROM ciclista WHERE nomequipo = "artiach"',
            'totalCount'=>$numero,
                'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['edad'], 
            "enunciado"=>"Listar las edad de los ciclistas de Artiach",
             "titulo"=>"Consulta 2",
            "sql"=>"SELECT DISTINCT ciclista.edad FROM ciclista WHERE ciclista.nomequipo = 'artiach';",
        ]);
    }
    public function  actionConsulta2a(){
        // mediante active record
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()
                ->distinct()
                ->select("edad")
                ->where("nomequipo = 'artiach'"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['edad'], 
            "enunciado"=>"Listar las edad de los ciclistas de Artiach",
             "titulo"=>"Consulta 2",
            "sql"=>"SELECT DISTINCT ciclista.edad FROM ciclista WHERE ciclista.nomequipo = 'artiach';",
        ]);
    }
    
    public function  actionConsulta3a(){
        // mediante active record
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()
                ->distinct()
                ->select("edad")
                ->where("nomequipo = 'artiach' OR nomequipo = 'Amore Vita' "),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['edad'], 
            "enunciado"=>"Listar las edad de los ciclistas de Artiach",
             "titulo"=>"Consulta 3",
            "sql"=>"SELECT DISTINCT ciclista.edad FROM ciclista WHERE ciclista.nomequipo = 'artiach' OR ciclista.nomequipo = 'Amore Vita';",
        ]);
    }
    public function  actionConsulta3(){
       // mediante DAO
        $numero=Yii::$app->
              db->
              createCommand("SELECT count(DISTINCT edad) FROM ciclista WHERE nomequipo = 'artiach' OR nomequipo = 'Amore Vita'")
              ->queryScalar();
              
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT DISTINCT edad FROM ciclista WHERE nomequipo = "artiach" OR nomequipo = "Amore Vita"',
            'totalCount'=>$numero,
                'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['edad'], 
            "enunciado"=>"Listar las edad de los ciclistas de Artiach o Amore Vita",
             "titulo"=>"Consulta 3",
            "sql"=>"SELECT DISTINCT ciclista.edad FROM ciclista WHERE ciclista.nomequipo = 'artiach'  OR ciclista.nomequipo = 'Amore Vita';",
        ]);
    }
     public function  actionConsulta4a(){
        // mediante active record
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()
                ->distinct()
                ->select("dorsal")
                ->where("edad < 25 OR edad > 30 "),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'], 
            "enunciado"=>"Listar los dorsales de los ciclistas de edad < 25 or > 30",
             "titulo"=>"Consulta 3",
            "sql"=>"SELECT ciclista.dorsal FROM ciclista WHERE  edad < 25 or > 30;",
        ]);
    }
    
    public function  actionConsulta4(){
        // mediante DAO
        $numero=Yii::$app->
              db->
              createCommand("SELECT count(dorsal) FROM ciclista WHERE edad < 25 OR edad > 30")
              ->queryScalar();
              
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT dorsal FROM ciclista WHERE edad < 25 OR edad > 30',
            'totalCount'=>$numero,
                'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'], 
            "enunciado"=>"Listar los dorsales de los ciclistas de edad < 25 O > 30",
             "titulo"=>"Consulta 3",
            "sql"=>"SELECT ciclista.dorsal FROM ciclista WHERE edad < 25 OR edad > 30;",
        ]);
    }
    
    public function  actionConsulta5a(){
        // mediante active record
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()
                ->distinct()
                ->select("dorsal")
                ->where("nomequipo = 'banesto'and edad BETWEEN 28 AND 32"),
            'pagination'=>[
                'pageSize'=>10,
            ]
        ]);
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'], 
            "enunciado"=>"Listar los dorsales de los ciclistas de edad  entre 28 y 32 años",
             "titulo"=>"Consulta 5",
            "sql"=>"SELECT ciclista.dorsal FROM ciclista WHERE nomequipo = 'banesto'and edad BETWEEN 28 AND 32 ;",
        ]);
    }
    public function  actionConsulta5(){
        // mediante DAO
        $numero=Yii::$app->
              db->
              createCommand("SELECT count(dorsal) FROM ciclista WHERE nomequipo = 'banesto'and edad BETWEEN 28 AND 32")
              ->queryScalar();
              
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT dorsal FROM ciclista WHERE nomequipo = "banesto" and edad BETWEEN 28 AND 32',
            'totalCount'=>$numero,
                'pagination'=>[
                'pageSize'=>10,
            ]
        ]);
        
        return $this->render("resultado", [
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'], 
            "enunciado"=>"Listar los dorsales de los ciclistas de edad  entre 28 y 32 años",
             "titulo"=>"Consulta 5",
            "sql"=>"SELECT ciclista.dorsal FROM ciclista WHERE nomequipo = 'banesto'and edad BETWEEN 28 AND 32;",
        ]);
    }
    public function  actionConsulta6a(){
        // mediante active record
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()
                ->distinct()
                ->select("nombre")
                ->where("CHAR_LENGTH(nombre) > 8"),
            'pagination'=>[
                'pageSize'=>10,
            ]
        ]);
        return $this->render("resultado", [

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php
use yii\helpers\Html;

echo Html::a('Ciclistas', ['ciclista/index'], ['class' => 'btn btn-primary btn-large']); /**/

echo '                         ';
echo Html::a('Equipo', ['equipo/index'], ['class' => 'btn btn-primary btn-large']); /**/

echo '                         ';
echo Html::a('Etapa', ['etapa/index'], ['class' => 'btn btn-primary btn-large']); /**/

echo '                         ';
echo Html::a('Puerto', ['puerto/index'], ['class' => 'btn btn-primary btn-large']); /**/

echo '                         ';
echo Html::a('Maillot', ['maillot/index'], ['class' => 'btn btn-primary btn-large']); /**/

echo '                         ';
echo Html::a('Lleva', ['lleva/index'], ['class' => 'btn btn-primary btn-large']); /**/

?>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de selección!</h1>
        <p class="lead">Modulo 3 Unidad 2</p>
    </div>

    <div class="body-content">
         <div class="row">
             <!--
             Boton de consulta
             -->
             
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 1</h3>
                    <p>Listar la edad de los ciclistas </p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta1a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta1'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
            <!--
             Boton de consulta dos
             -->
             
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 2</h3>
                    <p>Listar lasedad de los ciclistas de Artiach </p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta2a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta2'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
             
             <!--
             Boton de consulta tres
             -->
             
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 3</h3>
                    <p>Listar la edad de los ciclistas de Artiach o Amore Vita</p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta3a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta3'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
         </div>   
        <div class="row">
             <!--
             Boton de consulta
             -->
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 4</h3>
                    <p>Listar los dorsales de los ciclistas  cuya edad sea menor que 25 o  mayor que 30 </p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta4a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta4'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
            
               <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 5</h3>
                    <p>Listar los dorsales de los ciclistas  cuya edad este entree  28 y 32 y ademas sean de Banesto</p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta5a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta5'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
             <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 6</h3>
                    <p>Indicar el nombre el numero de los ciclistas  sea mayor que ocho(8) </p>
                    <?= Html::a('Active record', ['site/consulta6a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta6'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
         </div> 
        <div class="row">
             <!--
             Boton de consulta
             -->
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 7</h3>
                    <p>Listar el nombre y los dorsales de los ciclistas con un campo nuevo con los nombres en mayuscula</p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta7a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta7'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 8</h3>
                    <p>Listar todos los ciclistas  que han llevado maillot MGE(amarillo)en alguna etapa etapas</p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta8a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta8'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
             <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 9</h3>
                    <p>Listar el  nombre de los puertos cuya altura es mayor que 1500</p>
                    <?= Html::a('Active record', ['site/consulta9a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta9'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
         </div> 
        <div class="row">
             <!--
             Boton de consulta
             -->
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 10</h3>
                    <p>Listar el dorsal de los ciclistas que hallan ganado algun puerto cuya pendiente sea mayor que 8 o cuya altura este entre 1800 y 3000</p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta10a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta10'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
            <div class="thumbnail">
                <div class="caption">
                    <h3>Consulta 11</h3>
                    <p>Listar el dorsal de los ciclistas que hallan ganado algun puerto cuya pendiente sea mayor que 8 y cuya altura este entre 1800 y 3000</p>
                    <p>
                    <?= Html::a('Active record', ['site/consulta11a'], ['class' => 'btn btn-primary']);?>
                    <?= Html::a('DAO', ['site/consulta11'], ['class' => 'btn btn-default']);?>
                    </p>
                </div>
            </div>
            </div>
        </div> 
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

<div class="jumbotron">
        <h1><?=$titulo;?></h1>
        <p class="lead"><?=$enunciado;?></p>
        <p class="lead"><?=$sql;?></p>
</div>



<?= GridView::widget([
    'dataProvider' => $resultados,
    'columns' => $campos,
]);
?>